'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = falcorReducer;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _deepmerge = require('deepmerge');

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _actions = require('./actions');

var initialState = { loading: false };

function falcorReducer(state, action) {
  if (state === undefined) state = initialState;

  switch (action.type) {
    case _actions.RETRIEVE_VALUE + '_REQUEST':
    case _actions.RETRIEVE_PATH + '_REQUEST':
    case _actions.RETRIEVE_PATHS + '_REQUEST':
    case _actions.SET_PATH + '_REQUEST':
    case _actions.SET_PATHS + '_REQUEST':
    case _actions.CALL_PATH + '_REQUEST':
      return _extends({}, state, { loading: true });

    case _actions.RETRIEVE_VALUE:
      return _extends({}, state, { loading: false });

    case _actions.RETRIEVE_PATH:
    case _actions.RETRIEVE_PATHS:
    case _actions.SET_PATH:
    case _actions.SET_PATHS:
    case _actions.CALL_PATH:
      var newState = _extends({}, state, { loading: false });
      if (!action.res) return newState;
      return _deepmerge2['default'](newState, action.res.json);

    case _actions.RETRIEVE_VALUE + '_FAILURE':
    case _actions.RETRIEVE_PATH + '_FAILURE':
    case _actions.RETRIEVE_PATHS + '_FAILURE':
    case _actions.SET_PATH + '_FAILURE':
    case _actions.SET_PATHS + '_FAILURE':
    case _actions.CALL_PATH + '_FAILURE':
      return _extends({}, state, { loading: false });

    case _actions.CLEAR:
      var loading = state.loading;

      return { loading: loading };

    default:
      return state;
  }
}

module.exports = exports['default'];